/* strmatch.c * Content-Type: TEXT/PLAIN; charset=cp866
 * This function taken from Apache 1.1
 * Match = 0, NoMatch = 1, Abort = -1
 * Based loosely on sections of wildmat.c by Rich Salz
 * Hmmm... shouldn't this really go component by component?
 */

int strcasecmp_match(char *str, char *exp) {
    int x,y;

    if ((str == NULL) || (exp == NULL)) return -1; else;
    for(x=0,y=0;exp[y];++y,++x) {
	if((!str[x]) && (exp[y] != '*'))
	    return -1;
	if(exp[y] == '*') {
	    while(exp[++y] == '*');
	    if(!exp[y])
		return 0;
	    while(str[x]) {
		int ret;
		if((ret = strcasecmp_match(&str[x++],&exp[y])) != 1)
		    return ret;
	    }
	    return -1;
	} else
	    if((exp[y] != '?') && (tolower(str[x]) != tolower(exp[y])))
		return 1;
    }
    return (str[x] != '\0');
} /* int strcasecmp_match(char *str, char *exp) */
